% arxiv2009_SFA2_rank
% script for producing the table data tab:rank in 
% Konen, W. (2009), 
% "On the numeric stability of the SFA implementation sfa-tk",
% http://arxiv.org/abs/cond-mat/????. 
%
% You need to activate the line
%    gam = (0*sin(nuf*0.0047*t) + sin(nuf*0.0005*t))/2;     % activate this line for arxiv2009_SFA2.m
% in function drive1.m

noisearr = [0, 1e-10, 1e-8, 1e-6, 1e-4];

for n=1:numel(noisearr)
    res=arxiv2009_SFA2(noisearr(n));
    if n==1 
        stdy1=res.ewarr(:,1);           % m
        g_eta=res.ewarr(:,1);           % m
        ranks=res.ewarr(:,1);           % m
    end; 
    stdy1=[stdy1 res.ewarr(:,6)];       % std(y_1) for GEN_EIG
    g_eta=[g_eta res.ewarr(:,8)];       % eta(y_1) for GEN_EIG
    ranks=[ranks res.ewarr(:,10)];      % rank(B)
end 
ranks = [ranks res.ewarr(:,11)];        % size(B) = xpdim
