dataset_init = importdata('data/dataset_polak.csv');
% columns are: 
%   personID    1,..,12 (more info: dataset_polak.xls, sheet Person
%   gestureId   0: circle, 1: frisbee, 2: hit, 3: bowling, 4: throw
%   trialId     10,...,129, each gesture pattern has unique trialID 
%   time        (only time counter 0..150, not the real time!)
%   x, y, z     acceleration in x,y,z-direction

INPUT_DIM = 30;
DO_PLOT=1;         % 1: plot for each gesture the trials 1..MAX_PLOT, 0: don't
MAX_PLOT=5;        % how many plots per gesture to show

gestures = unique (dataset_init(:,2)); %unterschiedliche Gestenklassen herausfiltern
l=1; %counter zum Hintereinanderhngen der neuen Datenstze in Preproc-Dataset
pattern_n = 1
for p=1:length(gestures)
    GESTURE_ID = gestures(p)%alle Werte eines Versuchs    
    %%%%%%%%%%%%%%%%%%%%%%%%%
    %% SubMatrix mit allen Pattern einer Klasse erstellen
    %%%%%%%%%%%%%%%%%%%%%%%%%
    counter = 0;
    for n=1:length(dataset_init)
        if dataset_init(n,2)==GESTURE_ID    
            counter = counter+1;
            dataset_class(counter,:) = dataset_init(n,:);
        end
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% SubMatrix fr jedes Pattern erstellen
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if DO_PLOT
        figure(10+p); clf; set(gcf, 'Position', [89 77 866 638]);    
        set(gcf,'Name',['Gesture ' num2str(GESTURE_ID)]);
    end
    trial= unique (dataset_class(:,3));
    length(trial)
    for m=1:length(trial)
        realclass(pattern_n) = GESTURE_ID;
        pattern_n = pattern_n+1;
        TRIAL_COUNTER = trial(m);%alle Werte eines Versuchs 
        counter = 0;
        for n=1:length(dataset_class)
            if dataset_class(n,3)==TRIAL_COUNTER    
                counter = counter+1;
                dataset_pattern(counter,:) = dataset_class(n,:);
            end
        end
        %%%%%%%%%%%%%%%%
        %% fr jedes Pattern Normierung und Interpolation durchfhren
        %%%%%%%%%%%%%%%%
        pattern_t = dataset_pattern(:,4);%spalte 4 = zeitstempel
        pattern_x = dataset_pattern(:,5);%spalte 5 = Beschleunigungswerte x-Richtung
        pattern_y = dataset_pattern(:,6);%spalte 6 = Beschleunigungswerte y-Richtung
        pattern_z = dataset_pattern(:,7);%spalte 7 = Beschleunigungswerte z-Richtung
        
        if DO_PLOT & m<MAX_PLOT
            subplot(3,1,1); hold on;
            plot(1:numel(pattern_x), pattern_x'); xlabel('x');
            subplot(3,1,2); hold on;
            plot(1:numel(pattern_y), pattern_y'); xlabel('y');
            subplot(3,1,3); hold on;
            plot(1:numel(pattern_z), pattern_z'); xlabel('z');
            figure(10+p);
            fprintf('[personID trialID] = [%d %d]\n',dataset_pattern(1,[1 3]));
            dummy=1; % set breakpoint here to study figs pattern-by-pattern
        end
        %%%%%%%%%%%%%%%%%%%%%%%%%%
        %% NORMIERUNG
        %%%%%%%%%%%%%%%%%%%%%%%%%%
        INPUT_DIM_FIRST = INPUT_DIM/3;
        t_max = max(pattern_t); %hchster zeitstempel fr berechnung der abstnde
        t_min = min(pattern_t); %kleinster zeitstempel fr berechnung der abstnde
        delta_t = t_max/INPUT_DIM_FIRST;
        for k=1:INPUT_DIM_FIRST
            t_new(k) = t_min+(k-1)*delta_t;
        end
        %%%%%%%%%%%%%%%%%%%%%%%%%%
        %% INTERPOLATION (linear)
        %% fr INPUT_DIM_FIRST Werte
        %%%%%%%%%%%%%%%%%%%%%%%%%%
        pattern_x_new = interp1(pattern_t, pattern_x, t_new);
        pattern_y_new = interp1(pattern_t, pattern_y, t_new);
        pattern_z_new = interp1(pattern_t, pattern_z, t_new);
        %% zu Preprocessed Dataset hinzufgen
        dataset_preproc(l,1:INPUT_DIM_FIRST*1) = pattern_x_new;
        dataset_preproc(l,(INPUT_DIM_FIRST*1)+1:INPUT_DIM_FIRST*2) = pattern_y_new;
        dataset_preproc(l,(INPUT_DIM_FIRST*2)+1:INPUT_DIM_FIRST*3) = pattern_z_new;
        if any((min(dataset_pattern(:,1:3))==max(dataset_pattern(:,1:3))) ~=1 )
            error('something wrong in dataset_pattern');
        end
        % personID, gestureID, trialID, t_max
        info_preproc(l,1:4)=[min(dataset_pattern(:,1:3)) t_max];
        l = l+1;
        clear dataset_pattern, clear pattern_t, clear pattern_x, clear pattern_y, clear pattern_z
        clear t_max, clear t_min, clear t_new, clear pattern_x_new, clear pattern_y_new, clear pattern_z_new
    end
    clear dataset_class, clear trial
end
nrec=l-1;
clear delta_t, clear gestures, clear k, clear l, clear m, clear n, clear p, clear counter, clear GESTURE_ID,
clear INPUT_DIM_FIRST, clear TRIAL_COUNTER

x = dataset_preproc;

x = x(1:nrec,1:INPUT_DIM);
info_preproc=info_preproc(1:nrec,1:4);
realclass=realclass(1:nrec);
save('data/class_pat_gest.mat','x','realclass','info_preproc');
