% script class_sweep
%       NSWEEP calls to CLASS_DEMO1 to collect some statistics
%
% See also: CLASS_DEMO1, CLASSIFY

    nsweep =10;
    
    pars.npatt=100;      % number of patterns per class
    pars.sigma=0.08;     % sigma of Gaussian noise added to prototypes
    pars.GENERATE_P=1;   % =1: generate synthetic class patterns x (& save on data/class_pat.mat)
                         % =0: load synthetic class patterns x from data/class_pat.mat   
    pars.MIXING=1;       % =1: nonlinear mixing of input variables, same for all classes
                         % =2: nonlinear mixing in x1 and x2, different for all classes
                         % other: no mixing
    pars.tstfrac=0.25;   % which fraction of the patterns becomes test patterns
    
    opts.idim=10;        % number of input dimensions
    opts.nclass=4;       % number of classes
    opts.ALIGNED=1;      % =1: align the Gaussian classifiers with coordinate axes 
                         % (recommended, this is more robust if the data distribution deviates
                         % largely from multivariate Gaussian). 
                         % =0: don't align, can be more precise if data are Gaussian. 
    opts.dographics=0;   % =0: no plots, =1: some plots, =2: more plots
    
    result = zeros(nsweep,4);
    for n=1:nsweep
        res = class_demo1(opts,pars);
        result(n,:) = [res.errtrn res.errtst];
    end
    
    fprintf('\nAfter nsweep = %g runs the error rates are:\n',nsweep);
    fprintf('           Training Data     Test Data     \n');
    fprintf('           with     w/o      with     w/o   SFA\n');
    fprintf('mean = %7.1f%% %7.1f%% %7.1f%% %7.1f%% \n',mean(result*100));
    fprintf('std  = %7.1f%% %7.1f%% %7.1f%% %7.1f%% \n', std(result*100));
