% script class_test.m: 
% Test the hypothesis, that adding more noisy patterns
% to each class (in the case of few patterns as compared to idim)
% stabilizes the result in the sense that the classfication error on new
% test data decreases
% We vary pars.ncopies=0,1,2,3 and compare the results

opts.ALIGNED=1;      % =1: align the Gaussian classifiers with coordinate axes 
                     % (recommended, this is more robust if the data distribution deviates
                     % largely from multivariate Gaussian). 
                     % =0: don't align, can be more precise if data are Gaussian. 
opts.dographics=2;   % =0: no plots, =1: some plots, =2: more plots
opts.dbg = 0;        % =1 for activating sfa_dbg in sfa2_step, else =0   

pars.GENERATE_P=9;   % =1: load 'Vowel.csv' (R mlbench), divide randomly in tst/trn
                     % =2: load 'vowel-context.data' (UCI repository, recommended)  
                     % =3: load 'vowel-train.csv', 'vowel-test.csv' (Renal assignment)
                     % =9: load 'class_pat_gest.mat' (gesture data Polak/Hein)
                     % =10: load 'hk_gesture_all.mat' (new gesture data K.Hein) 
pars.tstdiv=1;       % =1: divide randomly in tst/trn even in case GENERATE_P=2 or 3
                     % =0: keep tst/trn from file in case GENERATE_P=2 or =3
pars.tstfrac=0.10;   % which fraction of the patterns become test 
                     % patterns in case of random divide
pars.tstvarseed=0;   % =1: vary seed, =0: always seed 0, for random number generator
                     % in case of random divide
errtrn = [];
errtst = [];
for nc=0:3
    pars.ncopies=nc;
    res = class_demo2(opts,pars);
    errtrn = [errtrn; res.errtrn];
    errtst = [errtst; res.errtst];
end
errtrn
errtst