% multi1_sweep
% generates Fig. 5 (fig:PT_multi, left) for arxiv2009.SFA

dographics=0;
docalc=0;

if docalc==1
    mmin=5;
    mmax=31;
    m = mmin:2:mmax;
    q = [0.1 0.3 0.5 0.6 0.7];
    phase=zeros(numel(m),numel(q));

    for j=1:numel(q)
        fmax=80; fstep=2; fmin=fstep; 
        for i=1:numel(m)
            phase(i,j) = drive1_sweep(m(i),q(j),fmin,fmax,fstep,dographics);
            if isnan(phase(i,j))
                fmax=80; fstep=2; fmin=fstep; 
            else
                if phase(i,j)>10
                    fmax=phase(i,j); fstep=2; fmin=max([fstep phase(i,j)-34]);
                else
                    a=10; 
                    if phase(i,j)<5, a=5;, end;
                    if phase(i,j) <2.5, a=2.5;, end;
                    fmax=a; fstep=a/10; fmin=fstep;
                end                
            end
            fprintf('[i j]=[%d %d],  [m(i) q(j]=[%d %5.1f]\n',i,j,m(i),q(j));
            fprintf('[fmin fstep fmax]=[%d %d %d]\n',fmin,fstep,fmax);
            dummy=1;
        end
    end
    readme = 'generated with multi1_sweep.m';

    save('phase01.mat','phase','m','q','readme');
else % if docalc==0
    load('phase01.mat'); 
    ind= [1:3 5];
    q=q(ind); phase=phase(:,ind);
end % if

[X,Y]=meshgrid(q,m);
figure(1); clf; axes('FontSize',16,'Box','on');
markers={'+';'o';'*';'x';'square'};
cmap = colormap(cool);
cfil = [0.66,0.76,1];
colors=[[0 0 0]; cmap(30,:); cmap(20,:); cmap(10,:); cmap(5,:)]; 
hold on;
for i=1:numel(q)
    plot(Y(:,i),phase(:,i),'LineWidth',2,'Marker',markers{i},'Color',colors(i,:),'MarkerSize',10);
end; 
legend([repmat('q=',numel(q),1) num2str(q')]);
fill([Y(4:14,1); Y(14,1)],[phase(4:14,1); phase(4,1)],cfil);
% plot the black line again to let it and its symbols appear in front of the blue fill
i=1; plot(Y(:,i),phase(:,i),'LineWidth',2,'Marker',markers{i},'Color',colors(i,:),'MarkerSize',10);
text(19,55,{'slower';'component';'detected'},...
     'HorizontalAlignment','center','BackgroundColor',cfil-0.07,'FontSize',14);
xlabel('embedding dimension m');   Xlim([5 31]);
ylabel('\nu(P.T.)');
hold off;
%print -f1 -depsc2 -r300 images/phasetrans_multi1.eps   % 'epsc2 important for color (!)