% multi2_sweep: 
% generates Fig. 5 (fig:PT_multi, right) for arxiv2009.SFA

dographics=1;
docalc=0;

if docalc==1
    mmin=5;
    mmax=31;
    fmax=40; fstep=2; fmin=40; 
    c.m=mmin:2:mmax; m=c.m;
    c.q=0.1; q=c.q;
    c.phase=zeros(numel(m),numel(q));
    c.gam=zeros(numel(m),numel(q));
    c.gamS=zeros(numel(m),numel(q));
    c.nu=fmax;

    for j=1:numel(q)
        for i=1:numel(m)
            [c.phase(i,j) corrmat] = drive1_sweep(m(i),q(j),fmin,fmax,fstep,dographics);
            c.gam(i,j)=abs(corrmat(1,1));
            c.gamS(i,j)=abs(corrmat(1,2));
            fprintf('[i j]=[%d %d],  [m(i) q(j]=[%d %5.1f]\n',i,j,m(i),q(j));
            dummy=1;
        end
    end

    d.m = 15; m=d.m;
    d.q = 0.1:0.1:0.9; q=d.q;
    fmax=40; fstep=2; fmin=40; 
    d.nu=fmax;
    d.phase=zeros(numel(m),numel(q));
    d.gam=zeros(numel(m),numel(q));
    d.gamS=zeros(numel(m),numel(q));

    for j=1:numel(q)
        for i=1:numel(m)
            [d.phase(i,j) corrmat] = drive1_sweep(m(i),q(j),fmin,fmax,fstep,dographics);
            d.gam(i,j)=abs(corrmat(1,1));
            d.gamS(i,j)=abs(corrmat(1,2));
            fprintf('[i j]=[%d %d],  [m(i) q(j]=[%d %5.1f]\n',i,j,m(i),q(j));
            dummy=1;
        end
    end
    readme = 'generated with multi2_sweep.m';

    save('phase02.mat','c','d','readme');
else % if docalc==0
    load('phase02.mat'); 
end % if

markers={'+';'o';'*';'x'};
cmap =colormap(cool);
colors=[[0 0 0]; cmap(30,:); cmap(20,:); cmap(10,:)]; 
%
figure2=figure(2); clf; 
subplot(2,1,1); 
set(gca,'FontSize',16,'Box','on');
xlabel('embedding dimension m');   xlim([5 31]);
ylabel('|Correlation|');
hold('all');
plot(c.m,c.gam(:,1) ,'LineWidth',2,'Marker',markers{1},'Color',colors(1,:),'MarkerSize',10);
plot(c.m,c.gamS(:,1),'LineWidth',2,'Marker',markers{2},'Color',colors(2,:),'MarkerSize',10);
text(28,0.85,{['q=' num2str(c.q)];['\nu_f=' num2str(c.nu)]},...
     'HorizontalAlignment','center','BackgroundColor',cmap(30,:),'Color',[1 1 1],'FontSize',16);
hold off;
%
subplot(2,1,2); 
set(gca,'FontSize',16,'Box','on');
colors=[[0 0 0]; cmap(30,:); cmap(20,:); cmap(10,:)]; 
hold on;
plot(d.q,d.gam(1,:) ,'LineWidth',2,'Marker',markers{1},'Color',colors(1,:),'MarkerSize',10);
plot(d.q,d.gamS(1,:),'LineWidth',2,'Marker',markers{2},'Color',colors(2,:),'MarkerSize',10);
legend('corr with \gamma','corr with \gamma_S','Location','Southwest');
text(0.9,0.85,{['m=' num2str(d.m)];['\nu_f=' num2str(d.nu)]},...
     'HorizontalAlignment','center','BackgroundColor',cmap(30,:),'Color',[1 1 1],'FontSize',16);
xlabel('predictability q');   XLim([0 1.0]); YLim([0.61 1.02]);
ylabel('|Correlation|');
hold off;
%
%print -f2 -depsc2 -r300 images/phasetrans_multi2.eps   % 'epsc2 important for color (!)