% multi3_sweep
% generates Tab. 1 (tab:eta) for arxiv2009.SFA

dographics=0;
docalc=1;

if docalc==1
    m = [5 10 15 20 30];
    q = [0.1 0.3 0.5 0.6 0.7];
    eta=zeros(numel(m),numel(q));
    nuf=40; 
    tau=1;
    allres = [];
    for j=1:numel(q)
        for i=1:numel(m)        
            res = drive1(m(i),tau,nuf,q(j),dographics);
            fprintf('(%2d,%5.1f) eta-value of gam, a*y_1+b, w and gam0: %8.5f,%8.5f,%8.5f,%8.5f\n', ...
                     m(i),q(j),res.eta);
            eta(i,j)=res.eta(2);
            allres = [allres; m(i) q(j) res.eta];
            dummy=1;
        end
    end
    readme = 'generated with multi3_sweep.m';

    save('eta01.mat','eta','m','q','readme');
else % if docalc==0
    load('eta01.mat'); 
end % if

num2str(q,'%6.1f')
num2str(eta,'%6.1f')