function handle=gaussCreate(nclass,y)
% Create an Gaussian classifier object.
%   HDL = gaussCreate(nclass,y)

%   See also gaussClassifier.m
  
  global GAUSS_STRUCTS
  
  % init if first call
  if isempty(GAUSS_STRUCTS),
    GAUSS_STRUCTS=cell(3,1);
  end
    
  % find empty slot
  handle=-1;
  for i=1:size(GAUSS_STRUCTS,1)
    if isempty(GAUSS_STRUCTS{i}),
      handle=i;
      break;
    end
  end
  if handle==-1, handle=size(GAUSS_STRUCTS,1)+1; end
  
  odim = size(y,2);
  GAUSS_STRUCTS{handle}.nclass=nclass;
  GAUSS_STRUCTS{handle}.odim=odim;
  GAUSS_STRUCTS{handle}.isTrained=0;
  GAUSS_STRUCTS{handle}.f0=zeros(nclass,1);       % normalization factor
  GAUSS_STRUCTS{handle}.P_c=zeros(nclass,1);      % apriori prob for class c
  GAUSS_STRUCTS{handle}.X0=zeros(nclass,odim);
  GAUSS_STRUCTS{handle}.COV=zeros(odim,odim,nclass);
  GAUSS_STRUCTS{handle}.iCOV=zeros(odim,odim,nclass);
end